/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

import (
	v1 "k8s.io/api/core/v1"
)

// ResourceHealthApplyConfiguration represents a declarative configuration of the ResourceHealth type for use
// with apply.
type ResourceHealthApplyConfiguration struct {
	ResourceID *v1.ResourceID           `json:"resourceID,omitempty"`
	Health     *v1.ResourceHealthStatus `json:"health,omitempty"`
}

// ResourceHealthApplyConfiguration constructs a declarative configuration of the ResourceHealth type for use with
// apply.
func ResourceHealth() *ResourceHealthApplyConfiguration {
	return &ResourceHealthApplyConfiguration{}
}

// WithResourceID sets the ResourceID field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the ResourceID field is set to the value of the last call.
func (b *ResourceHealthApplyConfiguration) WithResourceID(value v1.ResourceID) *ResourceHealthApplyConfiguration {
	b.ResourceID = &value
	return b
}

// WithHealth sets the Health field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Health field is set to the value of the last call.
func (b *ResourceHealthApplyConfiguration) WithHealth(value v1.ResourceHealthStatus) *ResourceHealthApplyConfiguration {
	b.Health = &value
	return b
}
